* ** Demo.PRG **


* Set up the Clipper environment.  This ensures us that each time we start
* up we start up in the same environment.
CLEAR ALL
CLEAR

* Declare those variables that are to be public and never erased.
PUBLIC Msetcursor, Mscreens[21]
Msetcursor=.T.                                    && Cursor is currently on.
AFILL(Mscreens,SPACE(0))                          && Used by ScrnSave() and ScrnRest() functions.
Mscreens[21]=1

SET CURSOR ON
SET COLOR TO (IF(ISCOLOR(),'W/B','W/N'))
CLEAR
@  0, 0,24,79 BOX REPLICATE(CHR(176),9)
@  4,12,20,67 BOX REPLICATE(CHR(177),9)
@  8,24,16,55 BOX REPLICATE(CHR(178),9)
@ 11,26 CLEAR TO 13,53
@ 12,26 SAY ' ScrnSave()/ScrnRest() Demo '
ScrnSave( 8,24,16,55)
ScrnSave( 4,12,20,67)
ScrnSave()


@ 24,17 SAY 'Press any key to restore the entire screen...'
INKEY(0)
SET COLOR TO (IF(ISCOLOR(),'B/W','N/W'))
CLEAR
INKEY(0.5)
ScrnRest()

@ 24,16 SAY 'Press any key to restore the screen by rows...'
INKEY(0)
SET COLOR TO (IF(ISCOLOR(),'B/W','N/W'))
@  4,12 CLEAR TO 20,67
INKEY(0.5)
ScrnRest(.T.,'R')

@ 24,15 SAY 'Press any key to restore the screen by columns...'
INKEY(0)
SET COLOR TO (IF(ISCOLOR(),'B/W','N/W'))
@  8,24 CLEAR TO 16,55
INKEY(0.5)
ScrnRest(.T.,'C')

@ 24, 0
@ 23, 0 SAY SPACE(0)
QUIT
* ** Demo.PRG **



***********************************************************************************
***********************************************************************************
***********************************************************************************



* Function...: ScrnSave()
* Written by.: Ronald D. Reed   (703) 787-9326
* Notice.....: (C) Copyright 1988, Personal Programming, All Rights Reserved
* Purpose....: To save a screen or portion thereof, to the next available
*              element in the Screens[] array.
* Parameters.: [<expN1>,<expN2>,<expN3>,<expN4>]
* Returns....: .T. / .F.    Normally returns .T.  Only returns .F. if there are
*                           no elements available.
* Note.......: Assumes the Mscreens[] array has been created, with a minimum of
*              21 elements.  Elements 1-10 are for saving the screens, 11-20
*              are for the screen attributes.  Element 21 keeps track of the
*              next available element.

FUNCTION ScrnSave
PARAMETERS M1, M2, M3, M4
PRIVATE Mreturn, Mlen

* Verify and test parameters passed.
M1=ParmDef('M1','N', 0)
M2=ParmDef('M2','N', 0)
M3=ParmDef('M3','N',24)
M4=ParmDef('M4','N',79)
Mlen=LEN(Mscreens)                                && Get the last element number.
Mreturn=(Mscreens[Mlen]<INT((Mlen-1)/2))          && Make sure there is an element left to save the screen to.

IF Mreturn
   * Save the screen then the cursor, colors and screen attributes.
   Mscreens[Mscreens[Mlen]]=SAVESCREEN(M1,M2,M3,M4)
   Mscreens[Mscreens[Mlen]+INT((Mlen-1)/2)]=STR(M1,2)+STR(M2,2)+STR(M3,2)+STR(M4,2)+ ;
      IF(Msetcursor,'1','0')+STR(ROW(),2)+STR(COL(),2)+SETCOLOR()
   Mscreens[Mlen]=Mscreens[Mlen]+1                && Increment the counter for the next screen save.
ENDIF

RETURN (Mreturn)
* ** ScrnSave() **



* Function...: ScrnRest()
* Written by.: Ronald D. Reed   (703) 787-9326
* Notice.....: (C) Copyright 1988, Personal Programming, All Rights Reserved
* Purpose....: To restore a screen or portion thereof, from the previous
*              element in the Screens[] array.
*              Optionally, a parameter of .F. may be passed which will release
*              the variable used by SaveScrn() and decrement the counter in
*              Screens[] but will not restore any screen.
* Parameters.: [<expL>[,<expC>]]
* Returns....: .T. / .F.    Normally returns .T.  Only returns .F. if there are
*                           no screens left to restore.
* Note.......: Assumes the Mscreens[] array has been created, with a minimum of
*              21 elements.  Elements 1-10 are for saving the screens, 11-20
*              are for the screen attributes.  Element 21 keeps track of the
*              next available element.

FUNCTION ScrnRest
PARAMETERS Mrestore, Mscroll
PRIVATE Mreturn, Mscrn, Mattr, Mtmp, Mtemp, Mlen, Mcntr, Mcntr2, ;
        Mtop, Mleft, Mbottom, Mright
Mrestore=ParmDef('Mrestore','L',.T.)
Mscroll=UPPER(ParmDef('Mscroll','C',SPACE(1)))

Mlen=LEN(Mscreens)
Mreturn=(Mscreens[Mlen]>1)                        && Do we have a screen to restore?
IF Mreturn
   Mscreens[Mlen]=Mscreens[Mlen]-1

   IF Mrestore
      Mscrn=Mscreens[Mscreens[Mlen]]              && Pull the screen string out.
      Mattr=Mscreens[Mscreens[Mlen]+INT((Mlen-1)/2)] && Pull the screen coordinates and attributes out.
      Mtop=VAL(SUBSTR(Mattr,1,2))                 && Top
      Mleft=VAL(SUBSTR(Mattr,3,2))                && Left
      Mbottom=VAL(SUBSTR(Mattr,5,2))              && Bottom
      Mright=VAL(SUBSTR(Mattr,7,2))               && Right

      IF Mscroll$'CR'                             && Do they want the screen scrolled back on?
         IF Mscroll='C'                           && Scroll by column - columns 79 to 0.
            Mtemp=(Mright-Mleft+1)*2              && Number of columns.
            FOR Mcntr=(Mright-Mleft+1) TO 1 STEP -1
                Mtmp=SPACE(0)                     && Build the screen variable 5 (10) characters at-a-time.
                FOR Mcntr2=((Mcntr*2)-1) TO (Mtemp*(Mbottom-Mtop+1)) STEP Mtemp
                    Mtmp=Mtmp+SUBSTR(Mscrn,Mcntr2,2)
                NEXT
                RESTSCREEN(Mtop,Mcntr+Mleft-1,Mbottom,Mcntr-1,Mtmp)
            NEXT
         ELSE                                     && Scroll by row - rows 0 to 24.
            Mtemp=(Mright-Mleft+1)*2              && Number of columns.
            FOR Mcntr=0 TO (Mbottom-Mtop) STEP 1
                RESTSCREEN(Mtop+Mcntr,Mleft,Mtop+Mcntr,Mright,SUBSTR(Mscrn,((Mcntr*Mtemp)+1),Mtemp))
                INKEY(0.05)
            NEXT
         ENDIF
      ELSE
         RESTSCREEN(Mtop,Mleft,Mbottom,Mright,Mscrn) && Restore the screen.
      ENDIF

      SET COLOR TO (SUBSTR(Mattr,14))             && Reset the colors.
      @ VAL(SUBSTR(Mattr,10,2)),VAL(SUBSTR(Mattr,12,2)) SAY SPACE(0) && Restore the cursor to its position.
      SetCursor((SUBSTR(Mattr,9,1)='1'))          && Restore the cursor (1=.T.=On).
   ENDIF

   Mscreens[Mscreens[Mlen]]=SPACE(0)              && Release memory variable space used.
   Mscreens[Mscreens[Mlen]+INT((Mlen-1)/2)]=SPACE(0)
ENDIF

RETURN (Mreturn)
* ** ScrnRest() **



* Function...: SetCursor()
* Written by.: Ronald D. Reed   (703) 787-9326
* Notice.....: (C) Copyright 1988, Personal Programming, All Rights Reserved
* Purpose....: Sets the cursor ON/OFF, updates the cursor status, returns
*              the current cursor status.
* Parameters.: <expL>/<expC>
* Returns....: .T./.F.  (current cursor status as contained in variable "Msetcursor")
* Note.......: 
*

FUNCTION SetCursor
PARAMETERS Mmode
PRIVATE Mreturn
Mreturn=Msetcursor                                && Return the current cursor status, .T. = ON.

IF PCOUNT()>0                                     && Did they request to reset the cursor?
   Mmode=ParmDef('Mmode','L',.F.)                 && Test the validity of the parameter only if one was passed.
   SET CURSOR (Mmode)                             && Set the cursor On/Off.
   Msetcursor=Mmode                               && Remember the status.
ENDIF

RETURN (Mreturn)
* ** SetCursor() **
